# MidiConvert

## Description

Converts a Renoise song into a MIDI file. Notes are grouped by instrument and exported per track.

The tool creates a menu entry called "Export Song to MIDI..." in the File menu, "Selection:Export to MIDI..." in the Pattern Editor menu, and an "Export Selection to MIDI" keybinding.

## Contributing

The code is decently commented, includes a generic Midi.lua class that can be reused for other tasks. Patches are welcome.

## Links

**Tool page (download)**: https://www.renoise.com/tools/midi-convert  
**Renoise Forum (discussion)**: http://forum.renoise.com/index.php/topic/28569-new-tool-30-midi-convert/

## Implemented Effect Commands:

### Pattern Commands
* ZTxx: Set BPM
* ZLxx: Set LPB
* ZKxx: Set TPL
* 0Qxx: Delay all notes by xx ticks

### MIDI Commands
* M0 xxyy: Set CC Number/Value

### Volume Column
* 00-80: Set volume of note
* Qx: Delay note for x ticks
* Cx: Cut note after x ticks

### Panning Column
* Qx: Delay note for x ticks
* Cx: Cut note after x ticks

### Delay Column
* 0-FF: Delay note


## Changelog

0.96
- Proper support for Renoise LPB commands 
- Allow MIDI-CC Commands without accompanying note
- Allow notes spanning multiple patterns

0.95
- Adds support for MIDI-CC Commands 

0.94
- Updated manifest.xml for compatibility with Renoise 3.1

0.92+0.93
- Fix where multiple consecutive notes could appear with zero length

0.91
- Updated manifest.xml for compatibility with Renoise 3.0